#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) x.size()
#define SH(x) cout<<(#x)<<" = "<<x<<'\n';

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 2e5 + 5;
const int C = 500;

int L, R;

int a[N];
int lg[N];
int sparse[N][20];
int pref[N];

int get_gcd(int l, int r) {
    int p = lg[r - l + 1];
    return __gcd(sparse[l][p], sparse[r - (1 << p) + 1][p]);
}

int get(int l, int r) {
    return get_gcd(l, r) * (pref[r] - pref[l - 1]);
}

void solve() {
    int n, cq;
    cin >> n >> cq;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        sparse[i][0] = a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    for (int j = 1; j < 20; ++j) {
        for (int i = 1; i <= n; ++i) {
            int jump = i + (1 << (j - 1));
            if (jump > n) sparse[i][j] = sparse[i][j - 1];
            else sparse[i][j] = __gcd(sparse[i][j - 1], sparse[jump][j - 1]);
        }
    }
    vector<array<int, 3>> Q(cq);
    for (int i = 0; i < cq; ++i) {
        cin >> Q[i][0] >> Q[i][1];
        Q[i][2] = i;
    }
//    sort(all(Q), [&](const auto &q1, const auto &q2) {
//        return (q1[0] / C == q2[0] / C ? q1[1] < q2[1] : q1[0] / C < q2[0] / C);
//    });
    for (int i = 0; i < cq; ++i) {
        auto [l, r, _i] = Q[i];
        int ans = 0;
        for (int j = l; j <= r; ++j) {
            for (int k = j; k <= r; ++k) {
                ans = max(ans, get(j, k));
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    lg[1] = 0;
    for (int i = 2; i < N; ++i) lg[i] = lg[i / 2] + 1;
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
