// M24C.cpp : This file contains the 'main' function. Program execution begins and ends there.
//


#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, k;
    cin >> n >> k;
    k++;

    vector<int> v(n,0);
    for (int i = 0; i < n; i++)
    {
        int inp;
        cin >> inp;
        v[inp-1] = i;
    }
    for (int i = 0; i < n; i++)
    {
        vector<int> smallres;
        vector<bool> b(n, false);
        int curpos = i;
        while (true)
        {
            if (b[curpos]) break;
            smallres.push_back(curpos + 1);
            b[curpos] = true;
            curpos = v[curpos];
        }
        ll sume = 0;
        for (int j = 0; j < smallres.size(); j++)
        {
            sume += smallres[j];
        }
        ll res = sume * (k / smallres.size());
        int mod = k % smallres.size();
        for (int c = 0; c < mod; c++)
        {
            res += smallres[c];
        }
        cout << res - i - 1 << " ";
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
