#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;


ll gcd(ll a, ll b)
{
    if (a == 0) return b;
    return gcd(b % a, a);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<ll> v;
    for (int i = 0; i < n; i++)
    {
        ll inp; cin >> inp;
        v.push_back(inp);
    }
    while (q--)
    {
        ll l, r; 
        cin >> l >> r;
        l--;
        ll maxres = 0;
        vector<ll> bgcd(n, 0);
        for (int i = l; i < r; i++)
        {
            ll curgcd = v[i];
            ll tsum = 0;
            for (int j = i; j < r; j++)
            {
                curgcd = gcd(v[j], curgcd);
                if (curgcd <= bgcd[j]) break;
                else bgcd[j] = curgcd;
                tsum += v[j];
                maxres = max(maxres, tsum * curgcd);
            }
        }
        cout << maxres << "\n";
    }
}