#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
const int inf = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m; cin>>n>>m;
    char s[n + 1][m + 1];
    vector<pii> st;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            cin>>s[i][j];
            if (s[i][j] == 'H'){
                st.push_back({i, j});
            }
        }
    }
    int out[n + 1][m + 1];
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            out[i][j] = 0;
        }
    }
    for (auto [x, y]: st){
        queue<pii> q;
        q.push({x, y});
        int dist[n + 1][m + 1];
        for (int i = 1; i <= n; i++){
            for (int j = 1; j <= m; j++){
                dist[i][j] = 0;
            }
        }
        dist[x][y] = 1;
        while (!q.empty()){
            pii t = q.front(); q.pop();
            int u = t.first, v = t.second;
            if (u > 1 && s[u - 1][v] != 'F' && !dist[u - 1][v]){
                dist[u - 1][v] = dist[u][v] + 1;
                q.push({u - 1, v});
            }
            if (v > 1 && s[u][v - 1] != 'F' && !dist[u][v - 1]){
                dist[u][v - 1] = dist[u][v] + 1;
                q.push({u, v - 1});
            }
            if (u < n && s[u + 1][v] != 'F' && !dist[u + 1][v]){
                dist[u + 1][v] = dist[u][v] + 1;
                q.push({u + 1, v});
            }
            if (v < m && s[u][v + 1] != 'F' && !dist[u][v + 1]){
                dist[u][v + 1] = dist[u][v] + 1;
                q.push({u, v + 1});
            }
        }
        for (int i = 1; i <= n; i++){
            for (int j = 1; j <= m; j++){
                if (s[i][j] != '.') continue;
                out[i][j] = max(out[i][j], dist[i][j]);
            }
        }
    }
    int mini = inf;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            if (s[i][j] != '.') continue;
            mini = min(mini, out[i][j]);
        }
    }
    vector<pii> ans;
    for (int i = 1; i <= n; i++){
        for (int j = 1; j <= m; j++){
            if (s[i][j] != '.') continue;
            if (out[i][j] == mini){
                ans.push_back({i, j});
            }
        }
    }
    cout<<ans.size()<<"\n";
    for (auto [i, j]: ans){
        cout<<i<<" "<<j<<"\n";
    }
}