#include <iostream>
#include <vector>
#include <queue>

using namespace std;
typedef long long ll;

ll gcd(ll a, ll b) {
    while (b) {
        ll t = a % b;
        a = b;
        b = t;
    }
    return a;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    vector<pair<int, int>> zp(q);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int i = 0; i < q; i++) {
        cin >> zp[i].first >> zp[i].second;
        zp[i].first--;
    }
    vector<vector<ll>> ans(n, vector<ll>(n + 1));
    for (int l = 0; l < n; l++) {
        ll gd = 0;
        ll sum = 0;
        for (int r = l + 1; r <= n; r++) {
            gd = gcd(gd, a[r - 1]);
            sum += a[r - 1];
            ans[l][r] = gd * sum;
        }
    }
    for (auto w : zp) {
        ll res = 0;
        for (int i = w.first; i < w.second; i++)
            for (int j = i + 1; j <= w.second; j++)
                res = max(res, ans[i][j]);
        cout << res << "\n";
    }
    return 0;
}   