c = list(map(int, input().split(" ")))

concat = lambda x, y: int(str(x) + str(y))

def heuristic(a: list[int]) -> int:
    acc = []
    for i in range(0, len(a)):
        for j in range(i, len(a)):
            acc.append(concat(a[i], a[j]))
    return sum(acc)

k = sum(c)

digits_counts = {}
for i in range(len(c)):
    digits_counts[i] = c[i]

# 0. Create a predicate that validates instances
# 1. Create an iterator to sample combinations from our constraints (take every possible combination, take only valid)
# 2. Calculate heuristic for each possible answer.
# 3. Print the one with the highest heuristic.
    
def is_valid(instance: list[int], expected_counts: dict[int, int]) -> bool:
    digits_counts = {}
    for i in instance:
        if digits_counts.get(i) == None: digits_counts[i] = 0
        digits_counts[i] += 1

    for k, v in expected_counts.items():
        if digits_counts.get(k, 0) == v:
            pass
        else:
            return False
    return True

choice = next(filter(lambda x: is_valid(x, digits_counts), map(lambda x: list(map(int, list(str(x)))), range(10**(k-1), 10**k))))
# choices = sorted(choices, key=heuristic)

print(" ".join(map(str, choice)))