#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void bfs(vector<vector<ll>>& ks, vector<pair<ll,ll>>& vect, vector<pair<ll,ll>>& dp, vector<ll>& d, ll n) {
    vector<bool> vis(n, false);
    ll ind = 0;
    for (int i = 0; i < n; i++) {
        ll s = d[i];
        bool check = false;
        ll time = 0;
        ll ln = 0;
        ll prev = 0;
        while (!vis[s]) {
            if (!check) ks.resize(ind + 1);
            check = true;
            vis[s] = true;
            vect[s].first = ind;
            vect[s].second = time;
            ks[ind].push_back(prev + s + 1);
            prev = ks[ind][ln];
            ln++;
            if (dp.size() <= ind) {
                dp.push_back({ 1,s + 1 });
            }
            else {
                dp[ind].first++;
                dp[ind].second += s + 1;
            }
            s = d[s];
            time++;
        }
        if (check) ind++;
    }
}

void solve() {
    ll n, k; cin >> n >> k;
    vector<ll> p(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        d[p[i] - 1] = i;
    }
    ll cnt = (k / n);
    ll s = n * (n + 1) / 2;
    vector<ll> ans(n, 0);
    vector<pair<ll,ll>> vect(n);
    vector<pair<ll, ll>> dp;
    vector<vector<ll>> ks;
    bfs(ks, vect, dp, d, n);
    for (int i = 0; i < n; i++) {
        ll ind = vect[i].first;
        ll sz = dp[ind].first;
        ll s = dp[ind].second;
        ll cnt = (k / sz);
        ans[i] += s * cnt;
        ll t = k-cnt*sz;
        ll e = i;
        ll t1 = vect[i].second;
        ll t2 = (t1 + t) % sz;
        ans[i] += (s + ks[ind][t2] - ks[ind][t1]) % s;
    }
    for (auto e : ans) {
        cout << e << " ";
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}