#include <bits/stdc++.h>
using namespace std;
typedef unsigned long long ll;

void solve() {
    ll n, q; cin >> n >> q;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    ll l, r;
    vector<vector<int>> gdp(n, vector<int>(n));
    for (ll i = 0; i < n; i++) {
        int g = a[i];
        for (ll j = i; j < n; j++) {
            g = gcd(g, a[j]);
            gdp[i][j] = g;
        }
    }
    vector<ll> b(n, a[0]);
    for (ll i = 1; i < n; i++) {
        b[i] = b[i - 1] + a[i];
    }
    for (ll ttt = 0; ttt < q; ttt++) {
        cin >> l >> r;
        l--; r--;
        ll ans = 0;
        ll i = l, j = r;
        for (;;) {
            if (i == j) {
                ans = max(a[i] * a[i], ans);
                break;
            }
            ll s = b[j] - b[i] + a[i];
            ll g = gdp[i][j];
            ans = max(ans, s * g);
            if ((s - a[j]) * gdp[i][j - 1] > (s - a[i]) * gdp[i + 1][j]) {
                j--;
            }
            else {
                i++;
            }
        }
        cout << ans << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
