#include <bits/stdc++.h>
using namespace std;
using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n, k;
    cin >> n >> k;

    int a[n + 1];

    int b[n + 1];

    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        b[a[i]] = i;
    }

    vector<vector<pair<int, int>>> cycles;
    cycles.reserve(n);

    bool seen[n + 1] = {};

    for (int i = 1; i <= n; i++) {
        if (!seen[i]) {
            vector<pair<int, int>> cycle;

            int cur = i;
            while (!seen[cur]) {
                cycle.push_back({b[cur], cur});
                seen[cur] = true;
                cur = b[cur];
            }

            cycles.push_back(cycle);
        }
    }

    ll ans[n + 1] = {};

    for (auto cycle : cycles) {
        int m = cycle.size();
        ll pref[2 * m + 1] = {};
        for (int j = 1; j <= 2 * m; j++) {
            pref[j] = pref[j - 1] + cycle[(j - 1) % m].first;
        }

        for (int j = 0; j < m; j++) {
            ans[cycle[j].second] += pref[m] * (k / m);
        }

        int left = k % m;

        for (int j = 0; j < m; j++) {
            ans[cycle[j].second] += pref[j + left] - pref[j];
        }
    }

    for (int i = 1; i <= n; i++) {
        printf("%lld ", ans[i]);
    }

    printf("\n");
}
