#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll n,k;
    cin>>n>>k;

    //find a cycle
    //do the leftover (k % cycleSize)

    vector<ll> permConstant(n);
    vector<ll> p1(n);
    vector<ll> p2(n);
    vector<ll> p1Copy(n);
    vector<ll> p2Copy(n);

    map<vector<ll>,bool> cycle;
    map<ll, vector<ll>> cntEveryStep;

    ll cnt[n+1]{};
    ll cntCopy[n+1]{};

    for(ll i=0; i<n; i++)
    {
        cin>>permConstant[i];
        p1[i]=i+1;
        p1Copy[i] = p1[i];
    }
    cycle[p1]=true;
    //looking for cycle
    for(ll ii=1; ii<=k; ii++)
    {
        vector<ll> unit(n+1); //saving cnt values for every step of ii
        for(ll i=0; i<n; i++)
        {
            p2[i] = p1[permConstant[i] - 1];
            cnt[p2[i]] += i+1; //getting xs
            unit[p2[i]] = i+1; //cnt only for this ii
        }
        cntEveryStep[ii] = unit; //saving only for this ii

        if(cycle[p2]) break;
        p1=p2;
        cycle[p2] = true;
    }


    //ll remains = cycle.size() - floor((ld)k / (ld)cycle.size());
    ll remains = cycle.size() - k%cycle.size();
    if(k % cycle.size() != 0 && k>cycle.size()) //then theres no remainder
    for(ll ii=1; ii<=remains; ii++)
    {

        for(ll i=1; i<=n; i++)
            cntCopy[i] += cntEveryStep[ii][i];
    }

    ld kc = max(floor((ld)k / (ld)cycle.size()),(ld)1);

    for(ll i=1; i<=n; i++)
        cout<<cnt[i]*kc + cntCopy[i]<<' ';
}
