#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,m;
    cin >> n >> m;
    vector<pair<int,int>> holes;
    vector<vector<char>> map(n,vector<char>(m));
    vector<vector<int>> dist(n,vector<int>(m));
    vector<vector<int>> mx(n,vector<int>(m,-1));
    for(int i = 0; i < n;i++){
        for(int j = 0;j < m;j++){
            cin >> map[i][j];
            if(map[i][j] == 'H') holes.push_back({i,j});
        }
    }
    queue<pair<int,int>> Q;
    for(auto e:holes){
        Q.push(e);
        for(int i = 0; i < n;i++)
            for(int j = 0; j < m;j++){
                if(map[i][j] == 'F') dist[i][j] = - 1;
                else dist[i][j] = 0;
            }
        dist[e.first][e.second] = 1;
        while(Q.size()){
            pair<int,int> v = Q.front();
            Q.pop();
            mx[v.first][v.second] = max(mx[v.first][v.second],dist[v.first][v.second]);
            if(v.first and dist[v.first-1][v.second] == 0){
                Q.push({v.first-1,v.second});
                dist[v.first-1][v.second] = dist[v.first][v.second]+1;
            }
            if(v.first < n-1 and dist[v.first+1][v.second] == 0){
                Q.push({v.first+1,v.second});
                dist[v.first+1][v.second] = dist[v.first][v.second]+1;
            }
            if(v.second and dist[v.first][v.second-1] == 0){
                Q.push({v.first,v.second-1});
                dist[v.first][v.second-1] = dist[v.first][v.second]+1;
            }
            if(v.second < m-1 and dist[v.first][v.second+1] == 0){
                Q.push({v.first,v.second+1});
                dist[v.first][v.second+1] = dist[v.first][v.second]+1;
            }
        }
    }
    vector<pair<int,int>> mx_ans;
    int mn_val = 1e9;
    for(int i = 0; i < n;i++){
        for(int j = 0; j < m;j++){
            //cout << mx[i][j] << " ";
            if(mx[i][j] == -1) continue;
            if(mx[i][j] < mn_val) mn_val = mx[i][j], mx_ans.clear();
            if(mx[i][j] == mn_val) mx_ans.push_back({i,j});
        }
        //cout << "\n";
    }
    cout << mx_ans.size() << "\n";
    for(auto e:mx_ans){
        cout << e.first+1 << " " << e.second+1 << "\n";
    }
}
