#pragma GCC optimze("O3,unroll-loops")
#pragma GCC target("arch=icelake-server")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
struct Node{
    int gcd_;
    int sum;
    ll ans;
    vector<pair<int,int>> gcd_L;
    vector<pair<int,int>> gcd_R;
    Node(){
        gcd_ = 0;
        sum = 0;
        ans = 0;
        gcd_L = {{0,0}};
        gcd_R = {{0,0}};
    }
    Node(int x){
        gcd_ = x;
        sum = x;
        ans = (ll)x*x;
        gcd_L = {{x,x}};
        gcd_R = {{x,x}};
    }
};
int gcd(int a, int b){
    if(a == 0) return b;
    if(b == 0) return a;
    return __gcd(a,b);
}
Node merge(const Node &left,const Node &right){
    Node tmp;
    tmp.ans = max(left.ans,right.ans);
    tmp.gcd_ = gcd(left.gcd_,right.gcd_);
    tmp.sum = left.sum+right.sum;
    for(auto e:left.gcd_R){
        for(auto E:right.gcd_L){
            tmp.ans = max(tmp.ans,((ll)e.first+E.first)*gcd(e.second,E.second));
        }
    }
    tmp.gcd_L = left.gcd_L;
    tmp.gcd_R = right.gcd_R;
    if(left.gcd_ != 1){
        int sum = left.sum;
        int gcdT = left.gcd_L.back().second;
        tmp.gcd_L.pop_back();
        for(auto e:right.gcd_L){
            if(gcd(gcdT,e.second) == gcdT){
                sum+=e.second;
            }else{
                tmp.gcd_L.push_back({sum,gcdT});
                sum+=e.second;
                gcdT = gcd(gcdT,e.second);
            }
        }
        tmp.gcd_L.push_back({sum,gcdT});
    }
    else{
        tmp.gcd_L.back().second = tmp.sum;
    }
    if(right.gcd_ != 1){
        int sum = right.sum;
        int gcdT = right.gcd_R.back().second;
        tmp.gcd_R.pop_back();
        for(auto e:left.gcd_R){
            if(gcd(gcdT,e.second) == gcdT){
                sum+=e.second;
            }else{
                tmp.gcd_R.push_back({sum,gcdT});
                sum+=e.second;
                gcdT = gcd(gcdT,e.second);
            }
        }
        tmp.gcd_R.push_back({sum,gcdT});
    }
    else{
        tmp.gcd_R.back().second = tmp.sum;
    }
    return tmp;
}
Node sgt[800001];
int a[200001];
void build(int v,int l,int r){
    if(l == r){
        sgt[v] = Node(a[l]);
    }
    else{
        int m = (l+r)/2;
        build(v<<1,l,m);
        build(v<<1|1,m+1,r);
        sgt[v] = merge(sgt[v<<1],sgt[v<<1|1]);
    }
}
Node get(int v,int l,int r,int tl,int tr){
    if(tl <= l and r<=tr) return sgt[v];
    int m = (l+r)/2;
    if(tr <= m) return get(v<<1,l,m,tl,tr);
    else if(tl > m) return get(v<<1|1,m+1,r,tl,tr);
    else return merge(get(v<<1,l,m,tl,m),get(v<<1|1,m+1,r,m+1,tr));
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin >> n >> q;
    for(int i = 0; i < n;i++)
        cin >> a[i];
    build(1,0,n-1);
    for(int i = 0;i < q;i++){
        int l,r;
        cin >> l >> r;
        l--;
        r--;
        cout << get(1,0,n-1,l,r).ans << "\n";
    }
}
// mx^2
// mx > n
// mx^2
// mx^2*cnt
// 6 6 6 6 9
// a, cnt
// b, cnt
// (a*cnta+b*cntb)*gcd(a,b)
// a^2*cnta
// 81, 36
// mx-c
// sum, gcd
// gcd/2
// sum >2
// cnt_a*a
// cnt_b*b
// cnt_c*c