#include <bits/stdc++.h>
using namespace std;
#define int long long
#define vt vector
vt<int> tree, a;
void build(int l, int r, int i){
    if(l==r){
        tree[i]=a[l]; return;
    }
    int m = (l+r)/2;
    build(l, m, 2*i+1); build(m+1, r, 2*i+2);
    tree[i]=gcd(tree[2*i+1], tree[2*i+2]);
}
int find(int l, int r, int real_l, int real_r){
    if(l==r) return tree[l];
    int m = (l+r)/2;
    if(real_l>=r || real_r<=l) return 0;
    if(m<real_l){
        return find(m+1, r, real_l, real_r);
    }
    if(m>real_r){
        find(l, m, real_l, real_r);
    }
    return gcd(find(l, m, real_l, real_r), find(m+1, r, real_l, real_r));
}
void solve(){
    int n, q;
    cin>>n>>q;
    a.resize(n); tree.resize(4*n+5);
    vt<int> p(n+1);
    for(int i=0; i<n; i++){
        cin>>a[i];
        p[i]=0;
        if(i>0){
            p[i]=a[i-1];
            p[i]+=p[i-1];
        }
    }
    if(n>1){
        p[n]=p[n-1]+a[n-1];
    }
    build(0, n-1, 0);
    vt<vt<int>> gcd1(n, vt<int>(n));
    for(int i=0; i<n; i++){
        int y=a[i];
        for(int j=i; j>=0; j--){
            if(j==i){ gcd1[i][j]=y; continue;}
            y=gcd(a[j], y);
            gcd1[i][j]=y;
        }
    }
    while(q--){
        int l, r;
        cin>>l>>r;
        int ans=0;
        for(int i=l; i<=r; i++){
            for(int j=l; j<=i; j++){
                ans=max(ans, (p[i]-p[j-1])*gcd1[i-1][j-1]);
            }
        }
        cout<<ans<<"\n";
    }
}
signed main(){
    int t=1;
    while(t--) solve();
}