#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    cin >> n >> m;
    vector<string> s(n);
    vector< vector<ll> > dist(n, vector<ll>(m, -INF));
    vector< pair<ll, ll> > h;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
        for (int j = 0; j < m; j++) {
            if (s[i][j] == 'H') {
                h.push_back({i, j});
            }
        }
    }
    for (int i = 0; i < h.size(); i++) {
        // cout << i << endl;
        queue< pair<ll, ll> > q;
        vector< vector<ll> > dist1(n, vector<ll>(m, INF));
        x = h[i].first;
        y = h[i].second;
        dist1[x][y] = 0;
        q.push({x, y});
        while (!q.empty()) {
            x = q.front().first;
            y = q.front().second;
            // cout << x << ' ' << y << endl;
            q.pop();
            if (x > 0 && s[x - 1][y] != 'F' && dist1[x - 1][y] == INF) {
                q.push({x - 1, y});
                dist1[x - 1][y] = dist1[x][y] + 1;
            }
            if (y > 0 && s[x][y - 1] != 'F' && dist1[x][y - 1] == INF) {
                q.push({x, y - 1});
                dist1[x][y - 1] = dist1[x][y] + 1;
            }
            if (x < n - 1 && s[x + 1][y] != 'F' && dist1[x + 1][y] == INF) {
                q.push({x + 1, y});
                dist1[x + 1][y] = dist1[x][y] + 1;
            }
            if (y < m - 1 && s[x][y + 1] != 'F' && dist1[x][y + 1] == INF) {
                q.push({x, y + 1});
                dist1[x][y + 1] = dist1[x][y] + 1;
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                dist[i][j] = max(dist[i][j], dist1[i][j]);
            }
        }
    }
    ll mn = INF;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            mn = min(mn, dist[i][j]);
        }
    }
    vector< pair<ll, ll> > ans;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (dist[i][j] == mn) {
                ans.push_back({i + 1, j + 1});
            }
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}
