#include <bits/stdc++.h>
using namespace std;

struct cicle{
    long long sum, bonus;
    int len, first_part;

    cicle(){
        sum = 0; 
        len = 0;
        bonus = 0;
        first_part = 0;
    }
};

void dfs(int index, int name, int cicles[], int perm[], cicle data_cicles[]){
    cicles[index] = name;
    ++data_cicles[name].len; data_cicles[name].sum += index+1;

    if (cicles[perm[index]] == -1)
        dfs(perm[index], name, cicles, perm, data_cicles);
}

void dfs2(int index, long long x[], cicle data_cicles[], int cicles[], int way[]){
    int c_index = index;
    for (int i = 0; i < data_cicles[cicles[index]].first_part; ++i){
        c_index = way[c_index];
        x[index] += c_index + 1;
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n, k; cin >> n >> k;
    int perm[n];
    for (int i = 0; i < n; ++i){
        cin >> perm[i]; --perm[i];
    }
    int way[n];
    for (int i = 0; i < n; ++i)
        way[perm[i]] = i;

    cicle data_cicles[n];
    int cicles[n], cnt = 0;
    for (int i = 0; i < n; ++i)
        cicles[i] = -1;
    for (int i = 0; i < n; ++i)
        if (cicles[i] == -1)
            dfs(i, cnt++, cicles, way, data_cicles);
    
    for (int i = 0; i < cnt; ++i){
        data_cicles[i].bonus = data_cicles[i].sum * (k / data_cicles[i].len);
        data_cicles[i].first_part = k % data_cicles[i].len;
    }

    long long x[n] = {0};
    for (int i = 0; i < n; ++i){
        dfs2(i, x, data_cicles, cicles, way);
    }

    for (int i = 0; i < n; ++i){
        cout << x[i] + data_cicles[cicles[i]].bonus << ' ';
    }
    cout << '\n';

    return 0;
}
