#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define lf long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define nl "\n"

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, x, y, p, o, q;
  string str;
  char ch;
  cin >> n >> k;
  vector<ll> permutation(n + 1);
  map<ll, ll> mp;
  vector<ll> positions(n + 1);
  ll remainders[n - 1][n + 1];
  for (ll i = 1; i <= n; i++) {
    cin >> permutation[i];
    mp[permutation[i]] = i;
    positions[i] = i;
    remainders[0][i] = i;
  }
  for (ll j = 1; j < n - 1; j++) {
    for (ll i = 1; i <= n; i++) {
      positions[i] = mp[positions[i]];
      remainders[j][i] = remainders[j - 1][i] + positions[i];
    }
  }
  c = k % (n - 1);
  e = k / (n - 1);
  for (ll i = 1; i <= n; i++) {
    d = remainders[n - 2][i] * e;
    d += remainders[c][i];
    d -= remainders[0][i];
    cout << d << " ";
  }
}
