#include <algorithm>
#include <cmath>
#include <iostream>
#include <map>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define nl "\n"

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ul n, m, k;
  ul a, b, c, d, e, f, x, y, p, o, q;
  string str;
  bool bl;
  char ch;
  cin >> n >> k;
  if (n == 1) {
    cout << k;
    return 0;
  }
  vector<ul> permutation(n + 1);
  map<ul, ul> mp;
  vector<ul> positions(n + 1);
  vector<ul> remainders[n + 1];
  for (ul i = 1; i <= n; i++) {
    cin >> permutation[i];
    mp[permutation[i]] = i;
    positions[i] = i;
    remainders[i].push_back(i);
  }
  for (ul j = 1; j <= k; j++) {
    f = j + 1;
    bl = true;
    for (ul i = 1; i <= n; i++) {
      positions[i] = mp[positions[i]];
      if (positions[i] != i)
        bl = false;
      remainders[i].push_back(remainders[i][j - 1] + positions[i]);
    }
    if (bl) {
      f--;
      break;
    }
  }
  c = k % f;
  e = k / f;
  for (ul i = 1; i <= n; i++) {
    d = remainders[i][f - 1] * e;
    d += remainders[i][c];
    d -= remainders[i][0];
    cout << d << " ";
  }
}
