#include <algorithm>
#include <climits>
#include <cmath>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define nl "\n"

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  long n, m, k;
  long a, b, c, d, e, f, x, y, p, o, q, l, r;
  string str;
  bool bl;
  char ch;
  cin >> n >> m;
  vector<long> vec(n);
  for (long i = 0; i < n; i++) {
    cin >> vec[i];
  }
  ll answer, current_sum, current_gcd;
  while (m--) {
    cin >> l >> r;
    l--;
    r--;
    answer = 0;
    for (ll tl = l; tl <= r; tl++) {
      current_sum = vec[tl];
      current_gcd = vec[tl];
      answer = max(answer, current_gcd * current_sum);
      for (ll tr = tl + 1; tr <= r; tr++) {
        current_sum += vec[tr];
        current_gcd = gcd(current_gcd, vec[tr]);
        answer = max(answer, current_gcd * current_sum);
      }
    }
    cout << answer << nl;
  }
}
