#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops")
using namespace std;

#define DIMN 200007

struct quer {
    long long l,r,ind;
};

long long n, nq;
long long a[DIMN];
long long res[DIMN];
quer q[DIMN]; 

void solve(long long l, long long r, vector<quer> q) {
    if (l==r) {
        for (auto i : q)
            res[i.ind] = max(res[i.ind],a[l]*a[l]);
        return;
    }

    long long m = (l+r)/2;
    vector<quer> lq,rq,v;
    for (auto i : q) {
        if (i.l <= m && i.r <= m) lq.push_back(i);
        else if (i.l > m && i.r > m) rq.push_back(i);
        else {
            //cout << i.l << " " << i.r << endl;
            long long ll = i.l, rr = i.r;
            v.push_back(i); 
            i.r = m; lq.push_back(i); i.r = rr;
            i.l = m+1; rq.push_back(i); i.l = ll;
            //cout << i.l << " " << i.r << endl;
        }
    }

    vector<pair<long long,long long>> dp(n);
    dp[m] = {a[m],a[m]};
    dp[m+1] = {a[m+1],a[m+1]};
    //unordered_map<long long,long long> mpl; mpl[dp[m].second] = dp[m].first;
    //unordered_map<long long,long long> mpr; mpr[dp[m+1].second] = dp[m+1].first;
    vector<pair<long long,pair<long long,long long>>> vl;
    vector<pair<long long,pair<long long,long long>>> vr;
    for (long long i = m-1; i >= l; i--) {
        dp[i] = {dp[i+1].first+a[i],__gcd(dp[i+1].second,a[i])};
        if (dp[i].second!=dp[i+1].second) {
            vl.push_back({i+1,dp[i+1]});
        }
    } 
    vl.push_back({l,dp[l]});
    for (long long i = m+2; i <= r; i++) {
        dp[i] = {dp[i-1].first+a[i],__gcd(dp[i-1].second,a[i])};
        //mpr[dp[i].second] = max(dp[i].first,mpr[dp[i].second]);
        if (dp[i].second!=dp[i-1].second) {
            vr.push_back({i-1,dp[i-1]});
        }
    } 
    vr.push_back({r,dp[r]});

    for (auto k : v) {
        long long lind = 0, rind = 0;
        long long maxres = 0;//(dp[k.l].first+dp[k.r].first)*__gcd(dp[k.l].second,dp[k.r].second);
        for (int i = 0; i < vl.size(); i++) {
            long long s1 = vl[i].second.first;
            long long g1 = vl[i].second.second;
            int p = 0;
            if (vl[i].first < l) {
                g1 = dp[l].second;
                s1 = dp[l].first;
                p = 1;
            }
            long long s2 = vr[rind].second.first;
            long long g2 = vr[rind].second.second;
            while(g2>g1) {
                rind--;
                g2 = vr[rind].second.second;
                s2 = vr[rind].second.first;
                if (vr[rind].first > r) {
                    g2 = dp[r].second;
                    s2 = dp[r].first;
                    break;
                }
            }
            maxres = max(maxres,(s1+s2)*__gcd(g1,g2));
            if (p) break;
        }
        //cout << maxres << " " << k.ind << endl;
        res[k.ind] = max(res[k.ind],maxres);
    }

    //for (long long i = l; i <= r; i++) cout << dp[i].first << " "; cout << endl;
    //for (long long i = l; i <= r; i++) cout << dp[i].second << " "; cout << endl;
    //for (auto i : mpl) cout << i.first << "-"<<i.second << endl; cout << endl;
    //for (auto i : mpr) cout << i.first << "-"<<i.second << endl; cout << endl;
    //for (auto i : vl) cout << i.first << " " << i.second.first << " " << i.second.second << endl; cout << endl;
    //for (auto i : vr) cout << i.first << " " << i.second.first << " " << i.second.second << endl; cout << endl;
    solve(l,m,lq);
    solve(m+1,r,rq);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> nq;
    for (long long i = 0; i < n; i++) cin >> a[i];
    vector<quer> v;
    for (long long i = 0; i < nq; i++) {
        cin >> q[i].l >> q[i].r; q[i].l--; q[i].r--;
        q[i].ind = i;
        v.push_back(q[i]);
    }
    solve(0,n-1,v);
    for (long long i = 0; i < nq; i++) {
        cout << res[i] << endl;
    }
}
