height, width = [int(i) for i in input().split(" ")]
garden=[]
starts = []
holes = []   
for i in range(height):
    garden.append(list(input()))   
for y in range(len(garden)):
    for x in range(len(garden[y])):
        if garden[y][x] == "H":
            holes.append((y, x))
            starts.append((y, x))
        elif garden[y][x] == ".":
            starts.append((y, x))
def newLayer(were, end):
    toAdd = []
    for start in were:
        moves = []
        if (start[0] - 1 >= 0 and garden[start[0]-1][start[1]] != "F"):
            moves.append((-1, 0))
        if (start[0] + 1 < height and garden[start[0]+1][start[1]] != "F"):
            moves.append((1, 0))
        if (start[1] - 1 >= 0 and garden[start[0]][start[1] - 1] != "F"):
            moves.append((0, -1))
        if (start[1] + 1 < width and garden[start[0]][start[1] + 1] != "F"):
            moves.append((0, 1))
        for move in moves: 
            if (move[0]+start[0], move[1]+start[1])==end:
                return True
            else: 
                if not (move[0]+start[0], move[1]+start[1]) in were:
                    toAdd.append((move[0]+start[0], move[1]+start[1]))
    return toAdd  
def wayLength(start, end):
    were = [start]
    depth = 0
    found = False
    while not found:
        response = newLayer(were, end)
        depth += 1
        if response == True:
            return depth
        else:
            were = were + response

answers = []
minLength = 1000000000
for start in starts:
    maxLength=0
    for hole in holes:
        length = wayLength(start, hole)
        maxLength = max(length, maxLength)
    if maxLength == minLength:
        answers.append(start)
    if maxLength < minLength:
        minLength = maxLength
        answers = []
        answers.append(start)
    
        
print(len(answers))
for i in answers:
    print(i[0]+1, i[1]+1)


