n, m = map(int, input().split())

matrix = []
for i in range(n):
    matrix.append([-1] * m)

sumArr = []
for i in range(n):
    sumArr.append([-1] * m)

holesI = []
holesJ = []

for i in range(n):
    inputRow = input()
    for j in range(m):
        if inputRow[j] == 'H':
            matrix[i][j] = 0
            sumArr[i][j] = 0
            holesI.append(i)
            holesJ.append(j)
        elif inputRow[j] == 'F':
            matrix[i][j] = -2
            sumArr[i][j] = -2

def maximum(arr):
    m = arr[0]
    for counter in range(len(arr)):
        if arr[counter] > m:
            m = arr[counter]
    return m 

def longestDistance(arr0, y, x, y_target, x_target, yArr, xArr):
    distArr = []
    for y_counter in range(y):
        distArr.append([-1] * x)
    
    for y_counter in range(y):
        for x_counter in range(x):
            if arr0[y_counter][x_counter] == -2:
                distArr[y_counter][x_counter] = -2
    
    queueY = [y_target]
    queueX = [x_target]
    positionsIterations = 1
    distance = 0
    distances = []
    while len(queueX) > 0:
        for counter in range(len(queueX)):
            if distArr[queueY[counter]][queueX[counter]] == -1:
                distArr[queueY[counter]][queueX[counter]] = distance

                if queueY[counter] > 0 and (distArr[queueY[counter]-1][queueX[counter]] == -1 or distArr[queueY[counter]-1][queueX[counter]] == 0):
                    queueY.append(queueY[counter]-1)
                    queueX.append(queueX[counter])
                if queueX[counter] > 0 and (distArr[queueY[counter]][queueX[counter]-1] == -1 or distArr[queueY[counter]][queueX[counter]-1] == 0):
                    queueY.append(queueY[counter])
                    queueX.append(queueX[counter]-1)
                if queueY[counter] < y-1 and (distArr[queueY[counter]+1][queueX[counter]] == -1 or distArr[queueY[counter]+1][queueX[counter]] == 0):
                    queueY.append(queueY[counter]+1)
                    queueX.append(queueX[counter])
                if queueX[counter] < x-1 and (distArr[queueY[counter]][queueX[counter]+1] == -1 or distArr[queueY[counter]][queueX[counter]+1] == 0):
                    queueY.append(queueY[counter])
                    queueX.append(queueX[counter]+1)

        distance += 1

        if positionsIterations > 0:
            for counter in range(positionsIterations):
                queueY.pop(0)
                queueX.pop(0)

        positionsIterations = len(queueX)

    for counter in range(len(yArr)):
        distances.append(distArr[yArr[counter]][xArr[counter]])

    result = maximum(distances)
    return result

for i in range(n):
    for j in range(m):
        if matrix[i][j] != -2:
            matrix[i][j] = longestDistance(matrix, n, m, i, j, holesI, holesJ)

minI = 0
minJ = 0
minimum = 99999999
for i in range(n):
    for j in range(m):
        if matrix[i][j] < minimum and matrix[i][j] >= 0:
            minI = i
            minJ = j
            minimum = matrix[i][j]

minIList = []
minJList = []
for i in range(n):
    for j in range(m):
        if matrix[i][j] == minimum:
            minIList.append(i)
            minJList.append(j)

print(len(minIList))
for counter in range(len(minIList)):
    s = ''
    s += str(minIList[counter]+1)
    s += ' '
    s += str(minJList[counter]+1)
    print(s)

'''......FFH
.F..FHFF.
HF.......
.FHF..FFF

12 11 10  9  8  7  F  F  H
13  F  9  8  F  6  F  F  1
14  F  8  7  6  5  4  3  2
15  F  9  F  7  6  F  F  F

6  5  4  3  2  1  F  F  6
7  F  5  4  F  H  F  F  5
8  F  4  3  2  1  2  3  4
9  F  5  F  3  2  F  F  F 

2  3  4  5  6  7  F  F 14
1  F  5  6  F  8  F  F 13
H  F  6  7  8  9 10 11 12
1  F  7  F  9 10  F  F  F 

5  4  3  4  5  6  F  F  9
6  F  2  3  F  5  F  F  8
7  F  1  2  3  4  5  6  7
8  F  0  F  4  5  F  F  F 

'''