#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>

using namespace std;

#define int long long
#define x first
#define y second
#define pb push_back
#define all(x) x.begin(),x.end()
#define sz(x) x.size()
#define SH(x) cout<<(#x)<<" = "<<x<<'\n';

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int N = 2e5 + 5;
const int M = 1e3 + 3;
const int C = 500;

int L, R;

int a[N];
int lg[N];
int sparse[N][20];
int pref[N];
int ans[N];
int mx[M][M];

int get_gcd(int l, int r) {
    int p = lg[r - l + 1];
    return __gcd(sparse[l][p], sparse[r - (1 << p) + 1][p]);
}

int get(int l, int r) {
    return get_gcd(l, r) * (pref[r] - pref[l - 1]);
}

void solve() {
    int n, cq;
    cin >> n >> cq;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
        sparse[i][0] = a[i];
        pref[i] = pref[i - 1] + a[i];
    }
    for (int j = 1; j < 20; ++j) {
        for (int i = 1; i <= n; ++i) {
            int jump = i + (1 << (j - 1));
            if (jump > n) sparse[i][j] = sparse[i][j - 1];
            else sparse[i][j] = __gcd(sparse[i][j - 1], sparse[jump][j - 1]);
        }
    }
    vector<array<int, 3>> Q(cq);
    bool is8 = 1;
    for (int i = 0; i < cq; ++i) {
        cin >> Q[i][0] >> Q[i][1];
        Q[i][2] = i;
        if (Q[i][0] != 1) is8 = 0;
    }
    if (is8) {
        sort(all(Q), [&](const auto &q1, const auto &q2) {
            return q1[1] < q2[1];
        });
        int ind = 0;
        int cur = 0;
        for (int i = 0; i < cq; ++i) {
            while (ind < Q[i][1]) {
                ind++;
                for (int d = 1; d * d <= a[ind]; ++d) {
                    if (a[ind] % d != 0) continue;
                    int l = 1, r = ind;
                    while (l < r) {
                        int mid = l + r >> 1;
                        if (get_gcd(mid, ind) % d == 0) r = mid;
                        else l = mid + 1;
                    }
                    cur = max(cur, get(l, ind));
                    if (d * d == a[ind]) continue;
                    int dd = a[ind] / d;
                    l = 1, r = ind;
                    while (l < r) {
                        int mid = l + r >> 1;
                        if (get_gcd(mid, ind) % dd == 0) r = mid;
                        else l = mid + 1;
                    }
                    cur = max(cur, get(l, ind));
                }
            }
            ans[Q[i][2]] = cur;
        }
        for (int i = 0; i < cq; ++i) cout << ans[i] << '\n';
        return;
    }
    if (n <= 1e3) {
        for (int i = 1; i <= n; ++i) {
            mx[i][i] = a[i] * a[i];
            for (int j = i - 1; j >= 1; --j) {
                mx[j][i] = mx[j][i - 1];
                for (int d = 1; d * d <= a[i]; ++d) {
                    if (a[i] % d != 0) continue;
                    int l = j, r = i;
                    while (l < r) {
                        int mid = l + r >> 1;
                        if (get_gcd(mid, i) % d == 0) r = mid;
                        else l = mid + 1;
                    }
                    mx[j][i] = max(mx[j][i], get(l, i));
                    if (d * d == a[i]) continue;
                    int dd = a[i] / d;
                    l = j, r = i;
                    while (l < r) {
                        int mid = l + r >> 1;
                        if (get_gcd(mid, i) % dd == 0) r = mid;
                        else l = mid + 1;
                    }
                    mx[j][i] = max(mx[j][i], get(l, i));
                }
            }
        }
        for (auto [l, r, _i] : Q) cout << mx[l][r] << '\n';
        return;
    }
    for (int i = 0; i < cq; ++i) {
        auto [l, r, _i] = Q[i];
        int ans = 0;
        for (int j = l; j <= r; ++j) {
            for (int d = 1; d * d <= a[j]; ++d) {
                if (a[j] % d != 0) continue;
                int l = j, rr = r;
                while (l < rr) {
                    int mid = l + rr + 1 >> 1;
                    if (get_gcd(j, mid) % d == 0) l = mid;
                    else rr = mid - 1;
                }
                ans = max(ans, get(j, l));
                if (d * d == a[j]) continue;
                int dd = a[j] / d;
                l = j, rr = r;
                while (l < rr) {
                    int mid = l + rr + 1 >> 1;
                    if (get_gcd(j, mid) % dd == 0) l = mid;
                    else rr = mid - 1;
                }
                ans = max(ans, get(j, l));
            }
        }
        cout << ans << '\n';
    }
}




signed main() {
    cin.tie(NULL)->ios_base::sync_with_stdio(false);
    lg[1] = 0;
    for (int i = 2; i < N; ++i) lg[i] = lg[i / 2] + 1;
    int t = 1;
//    cin >> t;
    while (t--) solve();
}
