#include <iostream>
#include <queue>
#include <vector>

using namespace std;
using ll = long long;

ll n, m;
vector<vector<char>> matrix;
vector<vector<pair<ll, ll>>> matrix1;
queue<pair<pair<ll, ll>, ll>> que;
queue<pair<pair<ll, ll>, ll>> que2;

void bfs(pair<pair<ll, ll>, ll> a, ll color) {
	if (a.first.first > 0 && matrix1[a.first.first-1][a.first.second].second != color && matrix[a.first.first - 1][a.first.second] != 'F') {
		que.push({ { a.first.first - 1, a.first.second }, a.second + 1 });
		if (matrix1[a.first.first - 1][a.first.second].first < a.second+1) {
			matrix1[a.first.first - 1][a.first.second] = { a.second + 1, color };
		}
		else {
			matrix1[a.first.first - 1][a.first.second].second = color;
		}
	}
	if (a.first.first < n-1 && matrix1[a.first.first + 1][a.first.second].second != color && matrix[a.first.first + 1][a.first.second] != 'F') {
		que.push({ { a.first.first + 1, a.first.second }, a.second + 1 });
		if (matrix1[a.first.first + 1][a.first.second].first < a.second+1) {
			matrix1[a.first.first + 1][a.first.second] = { a.second + 1, color };
		}
		else {
			matrix1[a.first.first + 1][a.first.second].second = color;
		}
	}
	if (a.first.second > 0 && matrix1[a.first.first][a.first.second - 1].second != color && matrix[a.first.first][a.first.second - 1] != 'F') {
		que.push({ { a.first.first , a.first.second - 1}, a.second + 1 });
		if (matrix1[a.first.first][a.first.second - 1].first < a.second+1) {
			matrix1[a.first.first][a.first.second - 1] = { a.second + 1, color };
		}
		else {
			matrix1[a.first.first][a.first.second - 1].second = color;
		}
	}
	if (a.first.second < m-1 && matrix1[a.first.first][a.first.second + 1].second != color && matrix[a.first.first][a.first.second + 1] != 'F') {
		que.push({ { a.first.first , a.first.second + 1}, a.second + 1 });
		if (matrix1[a.first.first][a.first.second + 1].first < a.second+1) {
			matrix1[a.first.first][a.first.second + 1] = { a.second + 1, color };
		}
		else {
			matrix1[a.first.first][a.first.second + 1].second = color;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll col = 1, min = 1000000000;
	vector<pair<ll, ll>> answers;
	cin >> n >> m;
	matrix.resize(n);
	matrix1.resize(n);
	for (ll i = 0; i < n; i++) {
		matrix[i].resize(m);
		matrix1[i].resize(m);
		for (ll j = 0; j < m; j++) {
			cin >> matrix[i][j];
			if (matrix[i][j] == 'H') {
				que2.push({ { i, j }, 0});
			}
			else if (matrix[i][j] == 'F') {
				matrix1[i][j] = { 1000000000, -1 };
			}
		}
	}
	while (!que2.empty()) {
		que.push(que2.front());
		matrix1[que2.front().first.first][que2.front().first.second].second = col;
		while (!que.empty()) {
			bfs(que.front(), matrix1[que.front().first.first][que.front().first.second].second);
			que.pop();
		}
		que2.pop();
		col++;
	}
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < m; j++) {
			if (matrix1[i][j].first < min) {
				min = matrix1[i][j].first;
				answers.clear();
				answers.push_back({ i, j });
			}
			else if (matrix1[i][j].first == min) {
				answers.push_back({ i, j });
			}
		}
	}
	cout << answers.size() << '\n';
	for (ll i = 0; i < answers.size(); i++) {
		cout << answers[i].first+1 << ' ' << answers[i].second+1 << '\n';
	}
}