#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;


ll gcd(ll a, ll b)
{
    if (a == 0) return b;
    return gcd(b % a, a);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<ll> v;
    for (int i = 0; i < n; i++)
    {
        ll inp; cin >> inp;
        v.push_back(inp);
    }
    vector<vector<pll>> peaks(n, vector<pll>());
    /*vector<pint> curgs;
    for (int i = 0; i < n; i++)
    {
        curgs.push_back(pint(v[i], v[i]));
    }
    for (int s = 1; s < n; s++)
    {
        for (int i = 0; i < n; i++)
        {
            int add_i = i + s;
            if (add_i >= n) break;
            if (curgs[i-1].first == curgs[i].first)
        }
    }*/
    for (int i = 0; i < n; i++)
    {
        ll curgcd = v[i];
        ll tsum = 0;
        ll maxres = 0;
        for (int j = i; j < n; j++)
        {
            curgcd = gcd(v[j], curgcd);
            tsum += v[j];
            ll tres = tsum * curgcd;
            if (tres > maxres)
            {
                maxres = tres;
                peaks[i].push_back(pll(j, maxres));
            }
            if (curgcd == 1) break;
        }
    }
    while (q--)
    {
        ll l, r; 
        cin >> l >> r;
        l--;
        ll maxres = 0;
        for (int i = l; i < r; i++)
        {
            int target = lower_bound(peaks[i].begin(), peaks[i].end(), pll(r, 0)) - peaks[i].begin() - 1;
            maxres = max(maxres, peaks[i][target].second);
        }
        cout << maxres << "\n";
    }
}