#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void bfs(vector<ll>& vect, vector<pair<ll,ll>>& dp, vector<ll>& d, ll n) {
    vector<bool> vis(n, false);
    ll ind = 0;
    for (int i = 0; i < n; i++) {
        ll s = d[i];
        bool check = false;
        while (!vis[s]) {
            check = true;
            vis[s] = true;
            vect[s] = ind;
            if (dp.size() <= ind) {
                dp.push_back({ 1,s + 1 });
            }
            else {
                dp[ind].first++;
                dp[ind].second += s + 1;
            }
            s = d[s];
        }
        if (check) ind++;
    }
}

void solve() {
    ll n, k; cin >> n >> k;
    vector<ll> p(n), d(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
        d[p[i] - 1] = i;
    }
    ll cnt = (k / n);
    ll s = n * (n + 1) / 2;
    vector<ll> ans(n, 0);
    vector<ll> vect(n);
    vector<pair<ll, ll>> dp;
    bfs(vect, dp, d, n);
    for (int i = 0; i < n; i++) {
        ll sz = dp[vect[i]].first;
        ll s = dp[vect[i]].second;
        ll cnt = (k / sz);
        ans[i] += s * cnt;
        ll t = k-cnt*sz;
        ll e = i;
        while (t-- > 0) {
            ans[i] += d[e] + 1;
            e = d[e];
        }
    }
    for (auto e : ans) {
        cout << e << " ";
    }
    cout << endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}