#include <bits/stdc++.h>
//#define int long long
using namespace std;

const int maxn = 1e6 + 10;

vector <vector <char>> a, used;
vector <vector <int>> res;
queue <pair <pair <int, int>, int>> Q;
int n, m, timer = 0;
vector <pair <int, int>> moves = {{1, 0}, {0, -1}, {-1, 0}, {0, 1}};

inline bool ok (int x, int y) {
    if (x < 0 || y < 0) return false;
    if (x >= n || y >= m) return false;
    if (a[x][y] == 'F' || used[x][y] == timer) return false;
    return true;
}

inline void bfs (int x, int y) {
    while (!Q.empty ()) Q.pop ();
    Q.push (make_pair (make_pair (x, y), 0));
    ++timer;
    used[x][y] = timer;
    while (!Q.empty ()) {
        pair <pair <int, int>, int> V = Q.front ();
        Q.pop ();
        int i = V.first.first, j = V.first.second;
        res[i][j] = max (res[i][j], V.second);
        for (auto d : moves) if (ok (i + d.first, j + d.second)) {
            Q.push (make_pair (make_pair (i + d.first, j + d.second), V.second + 1));
            used[i + d.first][j + d.second] = timer;
        }
    }
}

signed main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize (n), used.resize (n), res.resize (n);
    for (auto &i : a) i.resize (m);
    for (auto &i : used) i.assign (m, 0);
    for (auto &i : res) i.assign (m, 0);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) cin >> a[i][j];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) if (a[i][j] == 'H') bfs (i, j);
    int mn = 1000000;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) if (a[i][j] != 'F') mn = min (mn, res[i][j]);
    vector <pair <int, int>> result = {};
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j) if (a[i][j] != 'F' && res[i][j] == mn) 
            result.push_back (make_pair (i + 1, j + 1));
    cout << (int) result.size () << '\n';
    for (auto i : result) cout << i.first << ' ' << i.second << '\n';
    return 0;
}