#include <bits/stdc++.h>
using namespace std;

int main() {#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>
#include <string>
#include <map>
#include <numeric>
#include <set>
#include <unordered_map>

using namespace std;

typedef long long lli;
#define LF '\n';


struct MyStruct
{
    lli s, gcd;
};

struct mydv
{
    lli max;
    vector<MyStruct> l;
    vector<MyStruct> r;
};

vector<lli> v;
vector<mydv> dv;

lli mygcd(lli a, lli b)
{
    if (a > b)swap(a, b);
    while (a != 0) {
        b = b % a;
        swap(a, b);
    }
    return b;
}

mydv merge(mydv a, mydv b)
{
    mydv res;
    res.max = max(a.max, b.max);
    for (auto to1 : a.r) {
        for (auto to2 : b.l) {
            res.max = max(res.max, (to1.s + to2.s) * mygcd(to1.gcd, to2.gcd));
        }
    }
    res.l = a.l;
    lli as = a.l[a.l.size()-1].s;
    lli agcd = a.l[a.l.size()-1].gcd;
    for (auto to : b.l)res.l.push_back({ as + to.s,mygcd(agcd,to.gcd) });
    res.r = b.r;
    lli bs = b.r[b.r.size() - 1].s;
    lli bgcd = b.r[b.r.size() - 1].gcd;
    for (auto to : a.r)res.r.push_back({ bs + to.s,mygcd(bgcd,to.gcd) });
    return res;
}

void build(lli a, lli l, lli r)
{
    if (l == r) {
        dv[a].max = v[l] * v[l];
        dv[a].l.push_back({ v[l],v[l] });
        dv[a].r.push_back({ v[l],v[l] });
        return;
    }
    lli m = (l + r) / 2;
    build(a * 2 + 1, l, m);
    build(a * 2 + 2, m + 1, r);
    dv[a] = merge(dv[a * 2 + 1], dv[a * 2 + 2]);
}

mydv get(lli a, lli tl, lli tr, lli l, lli r)
{
    if (tr<l || tl>r)return { -1,{},{} };
    if (tl >= l && tr <= r)return dv[a];
    lli tm = (tl + tr) / 2;
    mydv x = get(a * 2 + 1, tl, tm, l, r);
    mydv y = get(a * 2 + 2, tm + 1, tr, l, r);
    if (x.max == -1)return y;
    if (y.max == -1)return x;
    return merge(x, y);
}

void solve()
{
    lli n, q;
    cin >> n >> q;
    v.resize(n + 1);
    dv.resize(4 * n);
    for (int i = 1; i <= n; i++)cin >> v[i];
    build(0, 1, n);
    for (int i = 1; i <= q; i++) {
        lli l, r;
        cin >> l >> r;
        cout << get(0, 1, n, l, r).max << LF;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}


    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    cout<<n/10<<" "<<n%10<<"\n";
}
