#include <iostream>
#include <vector>
#include <list>
#include <iterator>
using namespace std;

#define f first
#define s second

pair<int, int> qs[100][200000];
int k[100] = {0};

pair<int, int> tq[200000];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin>>n>>m;
    vector<vector<int>> field(n, vector<int>(m, -2));
    vector<vector<vector<int>>> f(n, vector<vector<int>>(m, vector<int>(100, 1000000)));
    
    char c;
    int n_holes = 0;
    for (int i=0;i<n;++i) {
        for (int j=0;j<m;++j){
            cin>>c;
            if (c == '.') field[i][j] = -1;
            if (c == 'H') {
                field[i][j] = 0;
                f[i][j][n_holes] = 0;
                qs[i][0] = make_pair(i, j);
                k[i] = 1;
                ++n_holes;
            }
            if (c == 'F') field[i][j] = -2;
        }
    }
    
    vector<vector<vector<bool>>> tick(n, vector<vector<bool>>(m, vector<bool>(n_holes, false)));
    bool flag = true;
    while (flag)
    {
        flag = false;
        for (int i=0;i<n_holes;++i)
        {
            int y = 0;
            for (int j=0;j<k[i];++j) {
                if (qs[i][j].f+1 < n && !tick[qs[i][j].f+1][qs[i][j].s][i]
                    && field[qs[i][j].f+1][qs[i][j].s] != -2
                    && f[qs[i][j].f+1][qs[i][j].s][i] > f[qs[i][j].f][qs[i][j].s][i]+1)
                {
                    tick[qs[i][j].f+1][qs[i][j].s][i] = true;
                    f[qs[i][j].f+1][qs[i][j].s][i] = f[qs[i][j].f][qs[i][j].s][i]+1;
                    field[qs[i][j].f+1][qs[i][j].s] = max(field[qs[i][j].f+1][qs[i][j].s], f[qs[i][j].f][qs[i][j].s][i]+1);
                    tq[y] = make_pair(qs[i][j].f+1, qs[i][j].s);
                    ++y;
                }

                if (qs[i][j].s+1 < m && !tick[qs[i][j].f][qs[i][j].s+1][i]
                    && field[qs[i][j].f][qs[i][j].s+1] != -2
                    && f[qs[i][j].f][qs[i][j].s+1][i] > f[qs[i][j].f][qs[i][j].s][i]+1)
                {
                    tick[qs[i][j].f][qs[i][j].s+1][i] = true;
                    f[qs[i][j].f][qs[i][j].s+1][i] = f[qs[i][j].f][qs[i][j].s][i]+1;
                    field[qs[i][j].f][qs[i][j].s+1] = max(field[qs[i][j].f][qs[i][j].s+1], f[qs[i][j].f][qs[i][j].s][i]+1);
                    tq[y] = make_pair(qs[i][j].f, qs[i][j].s+1);
                    ++y;
                }

                if (qs[i][j].f-1 > -1 && !tick[qs[i][j].f-1][qs[i][j].s][i]
                    && field[qs[i][j].f-1][qs[i][j].s] != -2
                    && f[qs[i][j].f-1][qs[i][j].s][i] > f[qs[i][j].f][qs[i][j].s][i]+1)
                {
                    tick[qs[i][j].f-1][qs[i][j].s][i] = true;
                    f[qs[i][j].f-1][qs[i][j].s][i] = f[qs[i][j].f][qs[i][j].s][i]+1;
                    field[qs[i][j].f-1][qs[i][j].s] = max(field[qs[i][j].f-1][qs[i][j].s], f[qs[i][j].f][qs[i][j].s][i]+1);
                    tq[y] = make_pair(qs[i][j].f-1, qs[i][j].s);
                    ++y;
                }

                if (qs[i][j].s-1 > -1 && !tick[qs[i][j].f][qs[i][j].s-1][i]
                    && field[qs[i][j].f][qs[i][j].s-1] != -2
                    && f[qs[i][j].f][qs[i][j].s-1][i] > f[qs[i][j].f][qs[i][j].s][i]+1)
                {
                    tick[qs[i][j].f][qs[i][j].s-1][i] = true;
                    f[qs[i][j].f][qs[i][j].s-1][i] = f[qs[i][j].f][qs[i][j].s][i]+1;
                    field[qs[i][j].f][qs[i][j].s-1] = max(field[qs[i][j].f][qs[i][j].s-1], f[qs[i][j].f][qs[i][j].s][i]+1);
                    tq[y] = make_pair(qs[i][j].f, qs[i][j].s-1);
                    ++y;
                }

            }
            k[i] = y;
            for (int j=0;j<k[i];++j) qs[i][j] = tq[j];
            if (y>0) flag = true;
        }
    }
    int min = 10000000;
    list<pair<int, int>> list_min;
    for (int i=0;i<n;++i) {
        for (int j=0;j<m;++j) {
            if (field[i][j]!=-2 && field[i][j] < min) {
                min = field[i][j];
                list_min.clear();
                list_min.push_back(make_pair(i+1, j+1));
            } else if (field[i][j] == min) {
                list_min.push_back(make_pair(i+1, j+1));
            }
        }
    }
    cout<<list_min.size()<<'\n';
    for (auto itr = list_min.begin();itr != list_min.end();++itr) cout<<itr->f<<' '<<itr->s<<'\n';
}
