#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
int gcd(int a,int b){
    if(a == 0) return b;
    if(b == 0) return a;
    return __gcd(a,b);
}
vector<pair<int,int>> gcd_L[200001];
vector<pair<int,int>> gcd_R[200001];
ll pref[200001];
int a[200001];
int sgt[800001];
void build(int v,int l,int r){
    if(l == r) sgt[v] = a[l];
    else{
        int m = (l+r)>>1;
        build(v<<1,l,m);
        build(v<<1|1,m+1,r);
        sgt[v] = gcd(sgt[v<<1],sgt[v<<1|1]);
    }
}
int get_R(int v,int l,int r,int st,int val){
    if(r < st) return -1;
    if(sgt[v]%val == 0) return -1;
    if(l == r){
        return l;
    }
    int m = (l+r)/2;
    if(st > m) return get_R(v<<1|1,m+1,r,st,val);
    else{
        int k = get_R(v<<1,l,m,st,val);
        if(k != -1) return k;
        return get_R(v<<1|1,m+1,r,m+1,val);
    }
}
int get_L(int v,int l,int r,int st,int val){
    if(l > st) return -1;
    if(sgt[v]%val == 0) return -1;
    if(l == r)
        return l;
    int m = (l+r)/2;
    if(st <= m) return get_L(v<<1,l,m,st,val);
    else{
        int k = get_L(v<<1|1,m+1,r,st,val);
        if(k != -1) return k;
        return get_L(v<<1,l,m,m,val);
    }
}
int get(int v,int l,int r,int tl,int tr){
    if(r < tl or tr < l) return 0;
    if(tl <= l and r <= tr) return sgt[v];
    int m = (l+r)/2;
    return gcd(get(v<<1,l,m,tl,tr),get(v<<1|1,m+1,r,tl,tr));
}
inline ll sum(int l,int r){
    if(l == 0) return pref[r];
    return pref[r]-pref[l-1];
}
struct sgt_max{
    vector<ll> sgt;
    void update(int v,int l,int r,int t,ll val){
        if(t > r or t < l) return;
        if(l == r){
            sgt[v] = max(sgt[v],val);
            return;
        }
        int m = (l+r)>>1;
        update(v<<1,l,m,t,val);
        update(v<<1|1,m+1,r,t,val);
        sgt[v] = max(sgt[v<<1],sgt[v<<1|1]);
    }
    ll get(int v,int l,int r,int tl,int tr){
        if(r < tl or tr < l) return 0;
        if(tl <= l and r <= tr) return sgt[v];
        int m = (l+r)/2;
        return max(get(v<<1,l,m,tl,tr),get(v<<1|1,m+1,r,tl,tr));
    }
};
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n,q;
    cin >> n >> q;
    for(int i = 0; i < n;i++){
        cin >> a[i];
        pref[i] = a[i];
        if(i) pref[i]+=pref[i-1];
    }
    build(1,0,n-1);
    for(int i = 0;i < n;i++){
        // R
        int tmp_val = a[i];
        int p = i;
        while(p != -1){
            p = get_R(1,0,n-1,p,tmp_val);
            if(p == -1) gcd_R[i].push_back({n-1,tmp_val});
            else{
                gcd_R[i].push_back({p-1,tmp_val});
                tmp_val = gcd(tmp_val,a[p]);
            }
        }
        // L
        tmp_val = a[i];
        p = i;
        while(p != -1){
            p = get_L(1,0,n-1,p,tmp_val);
            if(p == -1) gcd_L[i].push_back({0,tmp_val});
            else{
                gcd_L[i].push_back({p+1,tmp_val});
                tmp_val = gcd(tmp_val,a[p]);
            }
        }
    }
//    for(int i = 0;i < n;i++){
//        cout << i << ":\n";
//        cout << "R: ";
//        for(auto e:gcd_R[i]) cout << e.first << "(" << e.second << ") ";
//        cout << "\n";
//        cout << "L: ";
//        for(auto e:gcd_L[i]) cout << e.first << "(" << e.second << ") ";
//        cout << "\n";
//    }
    vector<ll> ans(q,0);
    vector<pair<pair<int,int>,int>> Q(q);
    for(int i = 0; i < q;i++){
        cin >> Q[i].first.second >> Q[i].first.first;
        Q[i].second = i;
        Q[i].first.second--;
        Q[i].first.first--;
        ans[i] = sum(Q[i].first.second,Q[i].first.first)*get(1,0,n-1,Q[i].first.second,Q[i].first.first);
        for(auto e:gcd_L[Q[i].first.first]){
            if(e.first >= Q[i].first.second){
                ans[i] = max(ans[i],sum(e.first,Q[i].first.first)*e.second);
            }
            else break;
        }
    }
    sgt_max sg;
    sg.sgt.resize(4*n);
    vector<vector<pair<int,ll>>> waiting(n);
    sort(Q.begin(), Q.end());
    int tr = 0;
    for(int i = 0; i < q;i++){
        while(tr <= Q[i].first.first){
            for(auto e:gcd_R[tr]){
                waiting[e.first].push_back({tr,sum(tr,e.first)*e.second});
            }
            for(auto e:waiting[tr]){
                sg.update(1,0,n-1,e.first,e.second);
            }
            waiting[tr].clear();
            tr++;
        }
        ans[Q[i].second] = max(ans[Q[i].second],sg.get(1,0,n-1,Q[i].first.second,Q[i].first.first));
    }
    for(int i = 0; i < q;i++){
        cout << ans[i] << "\n";
    }
}
