#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pldld;
const ll INF = 1e6+5, LONGBOI = 1e14+5;
mt19937 REALrandom(chrono::system_clock::to_time_t(chrono::system_clock::now()));

struct str{
    vector<ll> n;
    ll sum;
    ll cnt;
    ll cycles;
    ll turnsleft;

    vector<ll> p;
    void build(){
        p.resize(cnt);
        for(int i=0; i < cnt; i++){
            if(i!=0) p[i] = p[i-1];
            else p[i] = 0;

            p[i] += n[i];
        }
        return;
    }
};

ll n, k, cnt;
ll a[INF], b[INF], used[INF], ans[INF];
ll pos[INF], vc[INF];
str v[INF];

void dfs(ll we){
    if(used[we] == 1) return;
    used[we] = 1;
    vc[we] = cnt;

    //cout << "we = " << we << " cycle = " << cnt << endl;

    pos[we] = v[cnt].n.size();
    v[cnt].n.push_back(we); //// position
    v[cnt].cnt++;
    v[cnt].sum += we;


    dfs(b[we]);
}

void second_dfs(ll we, ll t){
    used[we] = 2;
    ll l = pos[a[we]];
    ll r = t + pos[a[we]];
    //cout << "we = " << we << " t = " << t << " pos[we] = " << pos[a[we]] << " l = " << l << " r = " << r << endl;

    ll k = 0;
    k -= v[vc[we]].p[l];
    if(r >= v[vc[we]].cnt){
        k += v[vc[we]].sum;
        r -= v[vc[we]].cnt;
        k += v[vc[we]].p[r];
    }
    else{
        k += v[vc[we]].p[r];
    }
    //cout << "we = " << we << " t = " << t << " my ans = " << k << endl;
    ans[a[we]] = k;
    return;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n >> k;
    for(int i=1; i <= n; i++) cin >> a[i];
    for(int i=1; i <= n; i++) b[a[i]] = i;

//    for(int i=1; i <= n; i++) cout << b[i] << " ";
//    cout << endl;

    for(int i=1; i <= n; i++){
        if(used[i] != 1) { cnt++; dfs(i); }
    }

    for(int i=1; i <= cnt; i++){
        v[i].cycles = k / v[i].cnt;
        v[i].turnsleft = k % v[i].cnt;
        v[i].build();
    }


    for(int i=1; i <= n; i++){
        if(used[i] == 2 || v[vc[i]].turnsleft == 0) continue;
        second_dfs(i, v[vc[i]].turnsleft);
    }

    for(int i=1; i <= n; i++){
        ans[i] += v[vc[i]].cycles * v[vc[i]].sum;
    }


    //// REAL ANS

    for(int i=1; i <= n; i++){
        cout << ans[i] << " ";
    }
    cout << endl;
    return 0;
}
