#include <algorithm>
#include <climits>
#include <cmath>
#include <iostream>
#include <map>
#include <numeric>
#include <queue>
#include <vector>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ul unsigned long
#define lf long double
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define nl "\n"

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);
  ll n, m, k;
  ll a, b, c, d, e, f, x, y, p, o, q, l, r;
  string str;
  bool bl;
  char ch;
  cin >> n >> m;
  vector<ll> vec(n);
  for (ll i = 0; i < n; i++) {
    cin >> vec[i];
  }
  ll answers[n][n];
  for (ll i = 0; i < n; i++) {
    a = vec[i];
    b = vec[i];
    answers[i][i] = a * b;
    for (ll j = i + 1; j < n; j++) {
      a += vec[j];
      b = gcd(b, vec[j]);
      answers[i][j] = max(answers[i][j - 1], a * b);
    }
  }
  while (m--) {
    cin >> l >> r;
    l--;
    r--;
    cout << answers[l][r] << nl;
  }
}
